
-- Called at the start of a game
function StartFirstTurn()
   WaitUntilNoActivity = false
   SendMessage("Timer.StartGame")
   StartTurn()
end


-- Перезаписать
function Custom_TurnStarted()

end

-- Перезаписать
function Custom_TurnEnded()

end

function SetupWormsAndTeams()

   WormIndex = 0
   TeamIndex = 0

   GM = QueryContainer("GM.GameInitData")

    if GM.NumberOfTeams>=1 then 
      SetupTeam(GM.T1_Name, T1_WormsCount, GM.T1_W1_Name, GM.T1_W2_Name, GM.T1_W3_Name, GM.T1_W4_Name, GM.T1_W5_Name, GM.T1_W6_Name,
               GM.T1_Skill, GM.T1_Grave, GM.T1_Flag, GM.T1_Speech, GM.T1_IsLocal, GM.T1_AlliedGroup,
			   SpawnBlue1, SpawnBlue2, SpawnBlue3, SpawnBlue4, SpawnBlue5, SpawnBlue6)
    end  
    if GM.NumberOfTeams>=2 then 
      SetupTeam(GM.T2_Name, T2_WormsCount, GM.T2_W1_Name, GM.T2_W2_Name, GM.T2_W3_Name, GM.T2_W4_Name, GM.T2_W5_Name, GM.T2_W6_Name,
               GM.T2_Skill, GM.T2_Grave, GM.T2_Flag, GM.T2_Speech, GM.T2_IsLocal, GM.T2_AlliedGroup,
			   SpawnRed1, SpawnRed2, SpawnRed3, SpawnRed4, SpawnRed5, SpawnRed6)
    end
    if GM.NumberOfTeams>=3 then 
      SetupTeam(GM.T3_Name, T3_WormsCount, GM.T3_W1_Name, GM.T3_W2_Name, GM.T3_W3_Name, GM.T3_W4_Name, GM.T3_W5_Name, GM.T3_W6_Name,
               GM.T3_Skill, GM.T3_Grave, GM.T3_Flag, GM.T3_Speech, GM.T3_IsLocal, GM.T3_AlliedGroup,
			   SpawnGreen1, SpawnGreen2, SpawnGreen3, SpawnGreen4, SpawnGreen5, SpawnGreen6)
    end  
    if GM.NumberOfTeams>=4 then 
      SetupTeam(GM.T4_Name, T4_WormsCount, GM.T4_W1_Name, GM.T4_W2_Name, GM.T4_W3_Name, GM.T4_W4_Name, GM.T4_W5_Name, GM.T4_W6_Name,
               GM.T4_Skill, GM.T4_Grave, GM.T4_Flag, GM.T4_Speech, GM.T4_IsLocal, GM.T4_AlliedGroup,
			   SpawnYellow1, SpawnYellow2, SpawnYellow3, SpawnYellow4, SpawnYellow5, SpawnYellow6)
    end
   
   SendMessage("WormManager.Reinitialise")
end



function SetupTeam(TeamName, NumWorms, Worm1Name, Worm2Name, Worm3Name, Worm4Name, Worm5Name, Worm6Name,
                   Skill, Grave, Flag, Speech, IsLocal, AlliedGroup,
				   TeamSpawnpoint1, TeamSpawnpoint2, TeamSpawnpoint3, TeamSpawnpoint4, TeamSpawnpoint5, TeamSpawnpoint6)

   local lock, team

   lock, team = EditContainer(GetTeamContainerName(TeamIndex)) 
   team.Active = true
   team.Name = TeamName
   team.TeamColour = 0
   team.Skill = Skill
   team.GraveIndex = Grave
   team.FlagGfxName = Flag
   team.AlliedGroup = AlliedGroup
   team.IsLocal = IsLocal
   if Skill>0 then
      team.IsAIControlled = true
   else
      team.IsAIControlled = false
   end

   -- PC: added this to reset the win count for the teams if this is the first round played.
   local iRounds = GetData("GameOver.RoundNumber")
   if iRounds == 0 
   then 
	team.RoundsWon = 0
   end

   CloseContainer(lock) -- must close the container ASAP

   if NumWorms>=1 then 
      SetupWorm(Worm1Name, Speech, TeamSpawnpoint1) 
   end   
   if NumWorms>=2 then 
      SetupWorm(Worm2Name, Speech, TeamSpawnpoint2) 
   end
   if NumWorms>=3 then 
      SetupWorm(Worm3Name, Speech, TeamSpawnpoint3) 
   end
   if NumWorms>=4 then 
      SetupWorm(Worm4Name, Speech, TeamSpawnpoint4) 
   end
   if NumWorms>=5 then 
      SetupWorm(Worm5Name, Speech, TeamSpawnpoint5) 
   end
   if NumWorms>=6 then 
      SetupWorm(Worm6Name, Speech, TeamSpawnpoint6) 
   end


   -- set the inventory
   --CopyContainer("Inventory.Team.Default", GetTeamInventoryName(TeamIndex))

   --SetSpecialWeapon(TeamIndex, SWeapon)
   TeamIndex = TeamIndex+1

end



function SetupWorm(Name, Speech, Spawn)
   
   local scheme = QueryContainer("GM.SchemeData")
   local lock, worm 

   lock, worm = EditContainer(GetWormContainerName(WormIndex))
   worm.Active = true
   worm.Name = Name
   worm.TeamIndex = TeamIndex
   worm.SfxBankName = Speech    
   worm.Energy = scheme.WormHealth
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false
   worm.Spawn = Spawn
   CloseContainer(lock)


   WormIndex = WormIndex +1
   
end

function StartTurn()
   done_once_per_turn_functions = false
   SendMessage("Timer.StartHotSeatTimer")
   SendMessage("GameLogic.ActivateNextWorm")
   SendMessage("Weapon.Create")
   SetWind()
   --TurnStarted()
   SendMessage("GameLogic.Turn.Started")
   TurnStarted() -- moved here so TeleportIn camera can override startofturn camera
   RunAILogic()
end


function RunAILogic()
	-- ovverride this function to now have AI.
	SendMessage("AI.PerformDefaultAITurn");
	-- actually called to start the AI turn.
	SendMessage("AI.ExecuteActions");
end

function Timer_HotSeatTimedOut()
   SendMessage("Timer.StartTurn")
end


function Weapon_PoweringUpStart()
   SendMessage("Timer.EndTurn")
   SendMessage("Weapon.DisableWeaponChange")
end


function Weapon_Fired_Start()
   -- Called when powering up finishes or fire button presses
   if MultiGir == true then
      local CurrentWorm = GetData("ActiveWormIndex")
      WormDataName = GetWormContainerName(CurrentWorm)
      local lock, worm = EditContainer(WormDataName)
      CurrentWeaponIndex = worm.WeaponIndex
      WormTeamIndex = worm.TeamIndex
      CloseContainer(lock)
      if CurrentWeaponIndex == "UtilityGirder" then
      SendMessage("Weapon.EnableWeaponChange")
      UserTeamData = GetTeamInventoryName(WormTeamIndex)
      local inventory_lock, inventory = EditContainer(UserTeamData) -- Open containers
      local delays_lock, delays = EditContainer("Inventory.WeaponDelays")
      delays.Girder = 1 -- Add one turn delay to girder (only one use per turn)
      CloseContainer(inventory_lock)
      CloseContainer(delays_lock)   
	  end
   else
      SendMessage("Timer.EndTurn")
      SendMessage("Weapon.DisableWeaponChange") 
   end

end


function Weapon_Fired_End()
   -- called after the short delay which plays the fire animation after which the missile is actually launched
   if MultiGir == true then
      local CurrentWorm = GetData("ActiveWormIndex")
      WormDataName = GetWormContainerName(CurrentWorm)
      local lock, worm = EditContainer(WormDataName)
      CurrentWeaponIndex = worm.WeaponIndex
      CloseContainer(lock)
      if CurrentWeaponIndex ~= "UtilityGirder" then
      SendMessage("Timer.StartRetreatTimer")
      SendMessage("Weapon.Delete")
      SendMessage("Timer.EndTurn")
	  end
   else
      SendMessage("Timer.StartRetreatTimer")
      SendMessage("Weapon.Delete")
   end

end


function GameLogic_EndTurn_Immediate()
   -- this called by surrender and skip go so they will work even if the above three
   -- functions have been emptied
   SendMessage("Weapon.Delete")
   SendMessage("Timer.EndTurn") 
   SendMessage("Weapon.DisableWeaponChange")
   EndTurn()
end


function Timer_RetreatTimedOut()
   EndTurn()
end


-- The worm whose turn it is has been damaged
function Worm_Damaged_Current()
   SendMessage("Weapon.Delete")
   SendMessage("Timer.EndRetreatTimer")
   SendMessage("Timer.EndTurn")  
   SendMessage("Weapon.DisableWeaponChange")
   EndTurn()
end


function Timer_TurnTimedOut()
   SendMessage("Weapon.Delete")
   SendMessage("Weapon.DisableWeaponChange")
   EndTurn()
end


-- Everything has come stopped moving
function Timer_PostActivityTimedOut()
   SendMessage("GameLogic.AboutToApplyDamage")
   SendMessage("GameLogic.ApplyDamage")
   CheckActivity()
end
   

function CheckActivity()
   Activity = GetData("ObjectCount.Active")
   if Activity == 0 then
      DoPostActivity()
   else
      WaitUntilNoActivity = true
   end
end

function DoPostActivity()
   if done_once_per_turn_functions == true then
      SendMessage("GameLogic.Turn.Ended") 
      TurnEnded()
   else 
      -- Done only once
      SendMessage("Worm.ApplyPoison")
      SetData("DoubleDamage", 0)
      DoOncePerTurnFunctions()
      done_once_per_turn_functions = true
      CheckActivity() -- in case an earthquake or similar was just started
   end
end

-- override this
function TurnStarted()
   TurnNumber = TurnNumber + 1

   
   local scheme = QueryContainer("GM.SchemeData")

   if MultiGir == true then
      local CurrentWorm = GetData("ActiveWormIndex")
      WormDataName = GetWormContainerName(CurrentWorm)
      local lock, worm = EditContainer(WormDataName)
      WormTeamIndex = worm.TeamIndex
      CloseContainer(lock)
	  UserTeamData = GetTeamInventoryName(WormTeamIndex)
	  local inventory_lock, inventory = EditContainer(UserTeamData) -- Open containers
      local delays_lock, delays = EditContainer("Inventory.WeaponDelays")
	  delays.Girder = 0 -- Remove girder delay
      CloseContainer(inventory_lock)
      CloseContainer(delays_lock)   
   else
   end
     
   if scheme.WormSelect == 1 then
      local scheme = QueryContainer("GM.SchemeData")
      SendMessage("WormSelect.OptionSelected")
   end
   if IsGameDM == true then
   TeleportIn() 
   end
   Custom_TurnStarted()

end

-- override this
function TurnEnded()
   Custom_TurnEnded()
   CheckOneTeamVictory()      
end



-- decides if the game has been won or drawn at the end of every turn
-- Note do this last in the TurnEnded function as it finishes with the StartTurn Message
function CheckOneTeamVictory()
   -- Changed to use alliances rather than teams so 2 teams vs 1 can end correctly
   SendMessage("WormManager.GetActiveAlliances")
   AllianceCount = GetData("AllianceCount")
   if AllianceCount == 0 then
      RoundOver()
      -- all the teams have just snuffed it
      SendMessage("GameLogic.Draw")
   elseif AllianceCount == 1 then
      RoundOver()
      -- only one team remains
      -- PC: changed this call to catch naughty use of GetActiveTeamIndex usage. Use the new 
      -- call to get the last team with a worm thats alive on it.
      SendMessage("WormManager.GetSurvivingTeam")
      WinningTeam = GetData("SurvivingTeamIndex")
      SendIntMessage("GameLogic.Win", WinningTeam)
   else
      StartTurn()
   end
   
end

-- game timer just ran out
function Timer_GameTimedOut()
   -- removed becasue incorrect to end a game mid turn wait until end of turn
   --RoundOver()
   --SendMessage("GameLogic.Draw")
end


function EndTurn()
   -- note: could this happen multiple times per turn (eg from WormDamagedCurrent)?
   -- if so does it matter?

   -- Poisoning now moved to DoPostActivity

   SendMessage("GameLogic.EndTurn")
  
   Activity = GetData("ObjectCount.Active")
   if Activity == 0 then
      SendMessage("Timer.StartPostActivity") -- pause
   else
      WaitUntilNoActivity = true
   end
end


-- If there was some activity its finished now
function GameLogic_NoActivity()
   if WaitUntilNoActivity == true then
      -- reset WaitUntilNoActivity before calling message below because zero time might
      -- cause it to call back immediately and set it true again
      WaitUntilNoActivity = false
      SendMessage("Timer.StartPostActivity")
   end
end



function SetWind()
   SelectRandomWind()
end


function SelectRandomWind()

   if WindEnabled == true then
   -- First the speed
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   SetData("Wind.Speed", RandomNumber*RandomNumber*MaxWind) -- now squared to make high winds less common

   -- Now a direction
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   Direction = RandomNumber * 2 * 3.14
   SetData("Wind.Direction", Direction) 
   else

   -- First the speed
   SetData("Wind.Speed", 0)

   -- Now a direction
   SetData("Wind.Direction", 0)  
   end   
end


function CreateExplosion(DetailObject, WormDamageMag, ImpulseMag, WormDamageRadius, LandDamageRadius, ImpulseRadius)

   SetData("Explosion.DetailObject", DetailObject)
   SetData("Explosion.WormDamageMagnitude", WormDamageMag)
   SetData("Explosion.ImpulseMagnitude", ImpulseMag)
   SetData("Explosion.WormDamageRadius", WormDamageRadius)
   SetData("Explosion.LandDamageRadius", LandDamageRadius)
   SetData("Explosion.ImpulseRadius", ImpulseRadius)
   SendMessage("Explosion.Construct")

end

function SubString( SourceResource, DestResource, SearchString, ReplacementString )
   SetData( "String.SourceDataName", SourceResource )
   SetData( "String.DestDataName", DestResource )
   SetData( "String.SearchString", SearchString )
   SetData( "String.ReplaceString", ReplacementString )
   SendMessage( "String.Substitute" )
end

function SubStringIndirect( SourceResource, DestResource, SearchString, ReplacementResource )
   SetData( "String.SourceDataName", SourceResource )
   SetData( "String.DestDataName", DestResource )
   SetData( "String.SearchString", SearchString )
   SetData( "String.ReplaceString", ReplacementResource )
   SendMessage( "String.SubstituteIndirect" )
end


function GetWormContainerName(Id)

   local DataId = { "Worm.Data00", "Worm.Data01", "Worm.Data02", "Worm.Data03",
                    "Worm.Data04", "Worm.Data05", "Worm.Data06", "Worm.Data07",
                    "Worm.Data08", "Worm.Data09", "Worm.Data10", "Worm.Data11",
                    "Worm.Data12", "Worm.Data13", "Worm.Data14", "Worm.Data15",
                    "Worm.Data16", "Worm.Data17", ""}
  
   -- indexed from 1
  return DataId[Id+1]

end


function GetTeamContainerName(Id)

   local DataId = { "Team.Data00", "Team.Data01", "Team.Data02", "Team.Data03", "" }
  
   -- indexed from 1
  return DataId[Id+1]

end

function GetTeamInventoryName(Id)

   local DataId = { "Inventory.Team00", "Inventory.Team01", "Inventory.Team02", "Inventory.Team03", "" }
  
   -- indexed from 1
  return DataId[Id+1]

end


function GetAllianceInventoryName(Id)

   local DataId = { "Inventory.Alliance00", "Inventory.Alliance01", "Inventory.Alliance02", "Inventory.Alliance03", "" }
  
   -- indexed from 1
  return DataId[Id+1]

end


function GetStockpileInventoryName(Id)

   local DataId = { "Inventory.Stockpile00", "Inventory.Stockpile01", "Inventory.Stockpile02", "Inventory.Stockpile03", "" }
  
   -- indexed from 1
  return DataId[Id+1]

end


function GetWormInventoryName(Id)

   local DataId = { "Inventory.Worm00", "Inventory.Worm01", "Inventory.Worm02", "Inventory.Worm04", 
					"Inventory.Worm05", "Inventory.Worm06", "Inventory.Worm07", "Inventory.Worm08",
					"Inventory.Worm09", "Inventory.Worm10", "Inventory.Worm11", "Inventory.Worm12",
					"Inventory.Worm13", "Inventory.Worm14", "Inventory.Worm15", "Inventory.Worm16",
					 "" }
  
   -- indexed from 1
  return DataId[Id+1]

end

function QueryWormContainer(...)

   if arg.n == 1 then
      Id = arg[1]
   else
      Id = GetData("ActiveWormIndex")
   end

   ContainerName = GetWormContainerName(Id)
   return  QueryContainer(ContainerName) 

end


function DoOncePerTurnFunctions()
   if IsGameDM == true then
      SendMessage("Stats.IgnoreWormDeath") -- no longer credit deaths to current worm
      CheckSuddenDeath()
      if RandomCrates == true then
	     SendMessage("GameLogic.DropRandomCrate")
      else
      end
	  if WormpotEnabled == true then
         DoWormpotOncePerTurnFunctions()
      else
      end
   else
   end
   
   Custom_DoOncePerTurnFunctions()

end

-- Override
function Custom_DoOncePerTurnFunctions()
end

function RoundOver()
end

function SetWormpotModes()
end

function CurrentWormContainer() -- Открыть контейнер червяка, который сейчас ходит.
   local CurrentWorm = GetData("ActiveWormIndex")
   local WormDataName = GetWormContainerName(CurrentWorm)
   lock, worm = EditContainer(WormDataName)
   return WormDataName
end

function ResetWind() -- Сброс ветра на ноль.
    -- First the speed
    SetData("Wind.Speed", 0)

    -- Now a direction
    SetData("Wind.Direction", 0) 
end

function ForceWin() -- Вызывает моментальную победу команды, которая сейчас ходит.
   CurrentWormContainer()
   WinningTeamIndex = worm.TeamIndex  
   CloseContainer(lock) 
   
   WinningTeam = WinningTeamIndex
   WinningTeamDataName = GetTeamContainerName(WinningTeam)
   local lock, team = EditContainer(WinningTeamDataName)
   team.RoundsWon = team.RoundsWon + 1
   CloseContainer(lock)
   SendIntMessage("GameLogic.Win", WinningTeam)
   SetData("Game.Victories", GetData("Game.Victories") + 1)
   RoundOver()
end

function CurrentTeamContainer() -- Открыть контейнер команды, которая сейчас ходит.
   CurrentWormContainer()
   CurrentTeamIndex = worm.TeamIndex  
   CloseContainer(lock) 
   
   CurrentTeamData = GetTeamContainerName(CurrentTeamIndex)
   lock, team = EditContainer(CurrentTeamData)
end

function DropCrate(Spawn, Type, Contents, NumContents, Index, Scale, HP, GroundSnap) -- Быстрый спавн ящика.
   SetData("Crate.Spawn", Spawn)
   SetData("Crate.Type", Type)
   SetData("Crate.NumContents", NumContents)
   SetData("Crate.Contents", Contents)
   SetData("Crate.TeamDestructible", 0)
   SetData("Crate.GroundSnap", GroundSnap)
   SetData("Crate.Pushable", 0)
   SetData("Crate.Index", Index)
   SetData("Crate.Scale", Scale)
   SetData("Crate.Hitpoints", HP)
   SendMessage("GameLogic.CreateCrate")
end

function EditWeapon(Weapon) -- Открыть контейнер оружия.
   local lock, weap = EditContainer(Weapon)
end

function Draw() -- Ничья
   RoundOver()
   SendMessage("GameLogic.Draw")
end

function CurrentTeamInventory() -- Открыть контейнер инвентаря команды, которая сейчас ходит.
   local CurrentWorm = GetData("ActiveWormIndex")
   WormDataName = GetWormContainerName(CurrentWorm)
   local lock, worm = EditContainer(WormDataName)
   WormTeamIndex = worm.TeamIndex
   CloseContainer(lock)
   UserTeamData = GetTeamInventoryName(WormTeamIndex)
   inventory_lock_dummy, inventory = EditContainer(UserTeamData) -- Open containers
   delays_lock_dummy, delays = EditContainer("Inventory.WeaponDelays")
end

function Square(Number) -- Не очень полезная функция, которая получает квадрат числа и выводит его.
   local Output = Number * Number
   return Output
end

function GetTurnNumber() -- Возвращает порядковый номер хода. В самом начале игры = 0, как только начнётся первый ход = 1, и т.д.
   local Output = TurnNumber
   return Output
end

function Rand(Min, Max)
   local Output = math.random(Min, Max)
   return Output
end

function RandBoolean()
   local PreOutput = math.random(0, 1)
   if PreOutput == 0 then
   local Output = false
   else
   local Output = true
   end
   
   return Output
end

function InitialiseGameMaster() -- Загрузка сервиса "Game Master".

   -- Загрузка счётчика ходов
   TurnNumber = 0
   
   -- Усиление оружия (Базука, мортира)
   if V_BoostWeapons == true then
   
   local lock, weap = EditContainer("kWeaponBazooka") -- Базука
   weap.ImpulseMagnitude = 0.25
   weap.MaxPower = 0.775
   CloseContainer(lock)
   
   local lock, weap = EditContainer("kWeaponMortar") -- Мортира
   weap.ImpulseMagnitude = 0.25
   weap.MaxPower = 0.775
   weap.BasePower = 0.775
   CloseContainer(lock)
   else
   end
   
   -- Мультиблок (Установка блока не тратит ход)
   if V_MultiGirder == true then
   
   MultiGir = true
   else
   MultiGir = false
   end
   
   -- Ветер (Вкл/Выкл)
   if V_Wind == true then
   
   WindEnabled = true
   else
   WindEnabled = false
   end
   
   -- Вормпот (Вкл/Выкл)
   if V_Wormpot == true then
   
   WormpotEnabled = true
   else
   WormpotEnabled = false
   end
   
   -- Дезматч (Вкл/Выкл)
   if V_Deathmatch == true then
   
   IsGameDM = true
   else
   IsGameDM = false
   end
   
   -- Рандомные ящики каждый ход
   if V_RandomCrates == true then
   
   RandomCrates = true
   else
   RandomCrates = false
   end
   
   -- Настройка количества червяков в команде
   if V_WormsCount == "Custom" then
   
   GM = QueryContainer("GM.GameInitData")
   
   T1_WormsCount = GM.T1_NumOfWorms
   T2_WormsCount = GM.T2_NumOfWorms
   T3_WormsCount = GM.T3_NumOfWorms
   T4_WormsCount = GM.T4_NumOfWorms
   
   else
   
   T1_WormsCount = V_WormsCount
   T2_WormsCount = V_WormsCount
   T3_WormsCount = V_WormsCount
   T4_WormsCount = V_WormsCount
   end
   
end